	;###########################################################################
; MMFCompare  (masm32)
;###########################################################################

.386
.model flat,stdcall
option casemap:none

.const
  __UNICODE__        equ   1
  STIF_DEFAULT       equ   0h
  STIF_SUPPORT_HEX   equ   1h
  WM_COPYGLOBALDATA  equ  49h
  id                 equ  100

include windows.inc
include c:\masm32\macros\macros.asm

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib ntdll
inclib kernel32
inclib user32
inclib shell32
inclib shlwapi
inclib gdi32
 inclib comctl32

SYSTEM_INFO struct
  wProcessorArchitecture       WORD  ?
  wReserved                    WORD  ?
  dwPageSize                   DWORD ?
  lpMinimumApplicationAddress  DWORD ?
  lpMaximumApplicationAddress  DWORD ?
  dwActiveProcessorMask        DWORD ?
  dwNumberOfProcessors         DWORD ?
  dwProcessorType              DWORD ?
  dwAllocationGranularity      DWORD ?
  wProcessorLevel              WORD  ?
  wProcessorRevision           WORD  ?
SYSTEM_INFO ends

LARGE_INTEGER_ union
  struct
   LowPart   DWORD ?
   HighPart  DWORD ?
  ends
 QuadPart  QWORD ?
LARGE_INTEGER_ ends

.data
.data?
  hinst  dd ?
  gran   dd ?
  uacdd  dd ?
;;  var    dd ?
;;  S_I    SYSTEM_INFO <>
  buf1   TCHAR MAX_PATH dup(?)
  buf2   TCHAR MAX_PATH dup(?)
.code

;###########################################################################

MMFCompare proc uses ebx edi esi lpbuf1:DWORD,lpbuf2:DWORD

  local L_I:LARGE_INTEGER_
  local li:LARGE_INTEGER_
  local hFile1:HANDLE
  local hFile2:HANDLE
  local hMapFile1:HANDLE
  local hMapFile2:HANDLE
  local lpMem1:DWORD
  local lpMem2:DWORD
  local var:DWORD
  local bytes:DWORD
  local err:DWORD
  local bu[1]:BYTE
  local buf[MAX_PATH]:TCHAR
  local buff[MAX_PATH]:TCHAR

  xor eax,eax
  mov hFile1,eax
  mov hFile2,eax
  mov hMapFile1,eax
  mov hMapFile2,eax
  mov var,eax
  mov err,eax  
  inc eax
  mov bytes,eax

;  invoke lstrcmpi,lpbuf1,lpbuf2
;  .if eax==0
;    mov err,10                                    ; "-- Same"
;    jmp @err
;  .endif
  
  invoke GetFileAttributes,lpbuf1
  .if eax==INVALID_FILE_ATTRIBUTES
    mov err,7                                     ; "-- Func error"
    jmp @err
  .else
    and eax,FILE_ATTRIBUTE_DIRECTORY
    .if eax!=0
      mov err,6                                   ; "-- File!=Directory"
      jmp @err
    .endif
  .endif

  invoke GetFileAttributes,lpbuf2
  .if eax==INVALID_FILE_ATTRIBUTES
    mov err,7                                     ; "-- Func error"
    jmp @err
  .else
    and eax,FILE_ATTRIBUTE_DIRECTORY
    .if eax!=0
      mov err,6                                   ; "-- File!=Directory"
      jmp @err
    .endif
  .endif

  invoke CreateFile,lpbuf1,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_READONLY or FILE_FLAG_SEQUENTIAL_SCAN,
                    0
  .if eax==INVALID_HANDLE_VALUE
    mov err,5                                     ; "-- INVALID_HANDLE_VALUE"
    jmp @err
  .else
    mov hFile1,eax
  .endif

  invoke CreateFile,lpbuf2,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_READONLY or FILE_FLAG_SEQUENTIAL_SCAN,
                    0 
  .if eax==INVALID_HANDLE_VALUE
    mov err,5                                     ; "-- INVALID_HANDLE_VALUE"
    jmp @err
  .else
    mov hFile2,eax
  .endif

  invoke RtlZeroMemory,addr L_I,sizeof L_I
  invoke GetFileSizeEx,hFile1,addr L_I
  .if eax==0
    mov err,4                                     ; "-- FileSize error"
    jmp @err
  .endif
  mov edi,L_I.LowPart
  mov esi,L_I.HighPart
  invoke RtlZeroMemory,addr L_I,sizeof L_I
  invoke GetFileSizeEx,hFile2,addr L_I
  .if eax==0
    mov err,4                                     ; "-- FileSize error"
    jmp @err
  .endif
  .if edi!=L_I.LowPart || esi!=L_I.HighPart
    mov err,13                                    ; "!= NotEqualSize"
    jmp @err
  .endif

  invoke CreateFileMapping,hFile1,
                           0,
                           PAGE_READONLY,
                           0,                     ; dwMaximumSizeHigh ; L_I.HighPart
                           0,                     ; dwMaximumSizeLow  ; L_I.LowPart
                           0                      ; lpName
  .if eax==0
    mov err,17                                    ; "-- CreateFileMapping error"
    jmp @err
  .else
    mov hMapFile1,eax
  .endif

  invoke CreateFileMapping,hFile2,
                           0,
                           PAGE_READONLY,
                           0,
                           0,
                           0
  .if eax==0
    mov err,17                                    ; "-- CreateFileMapping error"
    jmp @err
  .else
    mov hMapFile2,eax
  .endif

  .if err==0

    xor ebx,ebx
    xor edi,edi
    mov li.HighPart,edi
    mov li.LowPart,edi

    .while TRUE
      mov edx,edi
      mov ecx,ebx
      mov eax,L_I.LowPart
      sub eax,ebx
      add ecx,eax
      jnc @f
      inc edx
@@:
      .if edx==L_I.HighPart && eax<=gran
        mov gran,eax
        inc var
      .endif

      invoke MapViewOfFile,hMapFile1,
                           FILE_MAP_READ,
                           edi,                   ; dwFileOffsetHigh
                           ebx,                   ; dwFileOffsetLow
                           gran                   ; dwNumberOfBytesToMap
      .if eax==0
        mov err,16                                ; "-- MapViewOfFile error"
        jmp @err
      .else
        mov lpMem1,eax
      .endif

      invoke MapViewOfFile,hMapFile2,
                           FILE_MAP_READ,
                           edi,
                           ebx,
                           gran
      .if eax==0
        mov err,16                                ; "-- MapViewOfFile error"
        jmp @err
      .else
        mov lpMem2,eax
      .endif

    .break .if err!=0

      invoke RtlCompareMemory,lpMem1,lpMem2,gran

      .if eax!=gran
        mov err,12                                ; "!= NotEqual"
      .endif
      push eax

;;      invoke FlushViewOfFile,lpMem1,0
;;      invoke FlushFileBuffers,hFile1

      invoke UnmapViewOfFile,lpMem1
      .if eax==0
        pop eax
        mov err,22                                ; "-- UnmapViewOfFile error"
        jmp @err
      .endif

;;      invoke FlushViewOfFile,lpMem2,0
;;      invoke FlushFileBuffers,hFile2      

      invoke UnmapViewOfFile,lpMem2
      .if eax==0
        pop eax
        mov err,22                                ; "-- UnmapViewOfFile error"
        jmp @err
      .endif

      pop eax
      .if err!=0 || var!=0
        add ebx,eax
    .break
      .endif
      add ebx,gran
      jnc @f
      inc edi
@@:
;;      inc cntr
;;      .if ch39==BST_CHECKED
;;        mov li.HighPart,edi
;;        mov li.LowPart,ebx
;;      .endif
    .endw
  .endif

;;  mov li.HighPart,edi
;;  mov li.LowPart,ebx
;;
;;  .if err!=0
;;    invoke SetFilePointerEx,hFile1,
;;                            ebx,
;;                            edi,
;;                            0,
;;                            FILE_CURRENT
;;    invoke ReadFile,hFile1,
;;                    addr bu,
;;                    bytes,
;;                    addr bytes,
;;                    0
;;    invoke SetFilePointerEx,hFile2,
;;                            ebx,
;;                            edi,
;;                            0,
;;                            FILE_CURRENT    
;;    invoke ReadFile,hFile2,
;;                    addr bu,
;;                    bytes,
;;                    addr bytes,
;;                    0
;;  .endif
  
@err:
  xor ebx,ebx
  .if hFile1!=ebx
    invoke CloseHandle,hFile1
    mov hFile1,ebx
  .endif
  .if hFile2!=ebx
    invoke CloseHandle,hFile2
    mov hFile2,ebx
  .endif
  .if hMapFile1!=ebx
    invoke CloseHandle,hMapFile1
    mov hMapFile1,ebx
  .endif
  .if hMapFile2!=ebx
    invoke CloseHandle,hMapFile2
    mov hMapFile2,ebx
  .endif

  .if err==0
    mov err,11                                    ; "== Equal"
  .endif

;;  invoke GetModuleHandle,0
;;  mov edx,eax
;;  invoke LoadString,edx,err,addr buf,MAX_PATH
;;  fn wsprintf,addr buff,"MMFCompare  result :    %s    [%d]",addr buf1,err
;;  fn MessageBox,0,addr buff,0,MB_SYSTEMMODAL

  mov eax,err
  ret
MMFCompare endp

;###########################################################################

CHANGEFILTERSTRUCT struct
  cbSize      DWORD ?
  ExtStatus   DWORD ?
CHANGEFILTERSTRUCT ends

DragDropUAC proc uses ebx edi esi hWnd:HWND,param:DWORD

  local cfs:CHANGEFILTERSTRUCT

  invoke RtlZeroMemory,addr cfs,sizeof cfs
  mov cfs.cbSize,sizeof cfs  
  lea esi,cfs
.data
  _cwmfx db "ChangeWindowMessageFilterEx",0
  _cwmf  db "ChangeWindowMessageFilter",0
.code
  .if param!=0
    mov edi,MSGFLT_ALLOW
  .else
    mov edi,MSGFLT_DISALLOW  ; MSGFLT_RESET 
  .endif
;  invoke ChangeWindowMessageFilterEx,hWnd,WM_DROPFILES,edi,addr cfs
;  invoke ChangeWindowMessageFilterEx,hWnd,WM_COPYGLOBALDATA,edi,addr cfs
  fn GetModuleHandle,"user32.dll"
  invoke GetProcAddress,eax,offset _cwmfx
  .if eax!=0
    mov ebx,eax
    push esi
    push edi
    push WM_DROPFILES
    push hWnd
    call ebx
    push esi
    push edi
    push WM_COPYGLOBALDATA
    push hWnd
    call ebx
  .endif

;  .if param!=0
;    mov edi,MSGFLT_ADD
;  .else
;    mov edi,MSGFLT_REMOVE
;  .endif  
;;  invoke ChangeWindowMessageFilter,WM_DROPFILES,ebx
;;  invoke ChangeWindowMessageFilter,WM_COPYGLOBALDATA,ebx
;  fn GetModuleHandle,"user32.dll"
;  invoke GetProcAddress,eax,offset _cwmf
;  .if eax!=0
;    mov ebx,eax
;    push edi
;    push WM_DROPFILES
;    call ebx
;    push edi
;    push WM_COPYGLOBALDATA
;    call ebx
;  .endif

  ret
DragDropUAC endp

;###########################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local rt:RECT
  local buf[MAX_PATH]:TCHAR
  local buff[MAX_PATH]:TCHAR
  local bu[MAX_PATH]:TCHAR
  

  .if uMsg==WM_CLOSE
    invoke EndDialog,hWnd,0

  .elseif uMsg==WM_DROPFILES
    invoke DragQueryFile,wParam,0,addr buf,MAX_PATH
    invoke DragFinish,wParam
    invoke GetCursorPos,addr pt
    invoke GetWindowRect,hWnd,addr rt
    mov eax,rt.bottom
    sub eax,rt.top
    shr eax,1
    add eax,rt.top
    .if pt.y >= eax
      mov edx,id+20
    .else
      mov edx,id+10
    .endif
    invoke SetDlgItemText,hWnd,edx,addr buf
    jmp @f

  .elseif uMsg==WM_NCLBUTTONDBLCLK
@@:
    invoke GetDlgItemText,hWnd,id+10,addr buf1,MAX_PATH
    invoke GetDlgItemText,hWnd,id+20,addr buf2,MAX_PATH
    invoke MMFCompare,addr buf1,addr buf2
    mov edx,eax
    invoke LoadString,hinst,edx,addr buf,MAX_PATH
    invoke lstrcpy,addr bu,addr buf
    lea edx,bu
    mov TCHAR ptr[edx+2*sizeof(TCHAR)],0
    fn wsprintf,addr buff,"%s  MMFCompare  result :    %s",addr bu,addr buf
    invoke SetWindowText,hWnd,addr buff

  .elseif uMsg==WM_SIZE
    invoke GetWindowRect,hWnd,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov ebx,rt.bottom
    sub ebx,rt.top
    shr ebx,1
    add ebx,rt.top
    mov edi,lParam
    mov esi,edi
    and edi,0FFFFh  ; width
    shr esi,16      ; height 
    invoke GetDlgItem,hWnd,id+10
    invoke SetWindowPos,eax,0,0,0,edi,ebx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
    invoke GetDlgItem,hWnd,id+20
    sub esi,ebx
    invoke SetWindowPos,eax,0,0,ebx,edi,esi,SWP_NOZORDER or SWP_FRAMECHANGED

  .elseif uMsg==WM_CTLCOLOREDIT
    invoke SetBkMode,wParam,TRANSPARENT
    invoke GetDlgCtrlID,lParam
    .if eax==id+20
      mov edi,White
      mov esi,BLACK_BRUSH
    .else
      mov edi,Black
      mov esi,WHITE_BRUSH
    .endif
    invoke SetTextColor,wParam,edi
    invoke GetStockObject,esi
    jmp @f

  .elseif uMsg==WM_INITDIALOG
    invoke GetSystemMenu,hWnd,0
    mov ebx,eax
    invoke AppendMenu,ebx,MF_SEPARATOR,0,0
    invoke LoadString,hinst,48,addr buf,MAX_PATH
    invoke AppendMenu,ebx,MF_STRING,0e080h,addr buf
    invoke ShowWindow,hWnd,SW_MINIMIZE
    invoke ShowWindow,hWnd,SW_RESTORE

  .elseif uMsg==WM_SYSCOMMAND && wParam==0e080h
    xor uacdd,1
    invoke GetSystemMenu,hWnd,0
    .if uacdd==0
      mov edx,MF_UNCHECKED
    .else
      mov edx,MF_CHECKED
    .endif
    invoke CheckMenuItem,eax,wParam,edx
    invoke DragDropUAC,hWnd,uacdd
    invoke InvalidateRect,hWnd,0,1

  .else
    xor eax,eax
    jmp @f
  .endif
  xor eax,eax
  inc eax
@@:
  ret
DlgProc endp

;###########################################################################

InitProc proc uses ebx edi esi

  local S_I:SYSTEM_INFO
  local var:DWORD

  invoke GetCommandLine
  mov edx,eax
  invoke CommandLineToArgv,edx,addr var
  mov edi,eax

  invoke GetSystemInfo,addr S_I
  mov eax,S_I.dwAllocationGranularity
  mov gran,eax
  mov ebx,eax

  .if var<3
    invoke GetModuleHandle,0
    mov hinst,eax
    invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  .else
   .if var>3
      invoke StrToIntEx,dword ptr[edi+3*4],STIF_SUPPORT_HEX,addr var
      .if eax==FALSE || (var<=0 || var>0FFFFh)  ; (if gran==10000h !)
        jmp @f
      .else
        mov eax,var
        mul ebx
        mov gran,eax
      .endif
    .endif

    invoke lstrcpy,addr buf1,dword ptr[edi+1*4]
    invoke lstrcpy,addr buf2,dword ptr[edi+2*4]
    invoke MMFCompare,addr buf1,addr buf2
  .endif
@@:
  ret
InitProc endp

;###########################################################################

start:
  invoke InitProc
  invoke ExitProcess,eax
  invoke InitCommonControls
end start

;###########################################################################
